package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERGeneralizedTime;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERUTCTime;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.SimpleTimeZone;

public class Time extends ASN1Encodable {
   DERObject time;

   public static Time getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(obj.getObject());
   }

   public Time(DERObject time) {
      if (!(time instanceof DERUTCTime) && !(time instanceof DERGeneralizedTime)) {
         throw new IllegalArgumentException("unknown object passed to Time");
      } else {
         this.time = time;
      }
   }

   public Time(Date date) {
      SimpleTimeZone var2;
      var2 = new SimpleTimeZone.<init>(0, "Z");
      SimpleDateFormat var3;
      SimpleDateFormat var10000 = var3 = new SimpleDateFormat;
      var3.<init>("yyyyMMddHHmmss");
      var10000.setTimeZone(var2);
      String date1;
      int var6;
      if ((var6 = Integer.parseInt((date1 = var3.format(date) + "Z").substring(0, 4))) >= 1950 && var6 <= 2049) {
         this.time = new DERUTCTime(date1.substring(2));
      } else {
         Time var7 = this;
         DERGeneralizedTime var4;
         var4 = new DERGeneralizedTime.<init>(date1);
         var7.time = var4;
      }

   }

   public static Time getInstance(Object obj) {
      if (obj instanceof Time) {
         return (Time)obj;
      } else if (obj instanceof DERUTCTime) {
         return new Time((DERUTCTime)obj);
      } else if (obj instanceof DERGeneralizedTime) {
         return new Time((DERGeneralizedTime)obj);
      } else {
         throw new IllegalArgumentException("unknown object in factory: " + obj.getClass().getName());
      }
   }

   public String getTime() {
      DERObject var1;
      return (var1 = this.time) instanceof DERUTCTime ? ((DERUTCTime)var1).getAdjustedTime() : ((DERGeneralizedTime)var1).getTime();
   }

   public Date getDate() {
      ParseException var10000;
      label35: {
         boolean var10001;
         DERObject var7;
         try {
            var7 = this.time;
         } catch (ParseException var4) {
            var10000 = var4;
            var10001 = false;
            break label35;
         }

         DERObject var5 = var7;

         boolean var8;
         try {
            var8 = var7 instanceof DERUTCTime;
         } catch (ParseException var3) {
            var10000 = var3;
            var10001 = false;
            break label35;
         }

         if (var8) {
            try {
               return ((DERUTCTime)var5).getAdjustedDate();
            } catch (ParseException var1) {
               var10000 = var1;
               var10001 = false;
            }
         } else {
            try {
               return ((DERGeneralizedTime)var5).getDate();
            } catch (ParseException var2) {
               var10000 = var2;
               var10001 = false;
            }
         }
      }

      ParseException var6 = var10000;
      throw new IllegalStateException("invalid date string: " + var6.getMessage());
   }

   public DERObject toASN1Object() {
      return this.time;
   }
}
